//ImporterImages_502f.js
// 19.05.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Multiplie la premire planche et importe les images du dossier slectionn

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il faut ouvrir un document InDesign.", "Attention");
	exit();
}

// document actuel, nombre de planches, nombre de blocs images
var curDoc = app.documents[0];
var nSpr = curDoc.spreads.length;
if (nSpr > 1) {
	alert ("Le document ne doit contenir qu'une seule planche.", "Stop");
	exit();
}
nFra = curDoc.rectangles.length;
if (nFra == 0) {
	alert ("Ce document ne contient pas de blocs images.", "Stop");
	exit();
}

// mmoriser les units
// quand cela n'est pas 2053991795 (= millimtres), modifier  millimtres 
vM = curDoc.viewPreferences.verticalMeasurementUnits;
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}

// slectionner le point de rfrence en haut  gauche
trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095660652) {
	app.layoutWindows[0].transformReferencePoint = 1095660652;
}

// 'sufString': une variable globale, contenant une liste de suffixes
sufString = "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";
// afficher le dialogue pour la slction du dossier
var selFolder = Folder.selectDialog("Slctionner le dossier contenant les images  importer.");
// dfinir le chemin au dossier source
if (selFolder != null) {
	var mainList = new Array ();
	var mainFiles = getMainFiles(selFolder, mainList);
	mainFileList = fileFilter1(mainFiles);
	nMain = mainFileList.length;
	
	if (nMain != 0) {
		// appeler la fonction qui lit les prfrences mmorises
		var defStr = getPrefs();
		// extraire les valeurs
		if (defStr != "") {
			var catDef = defStr.split("\n");
			pVal = catDef[0]*1;
			if (pVal == 0) {pVal = "";}
			hOff = catDef[1]*1;
			vOff = catDef[2]*1;
			nNam = catDef[3];
			if (nNam == "false") {nNam = false;}
			else {nNam = true;}
			fNam = catDef[4];
			if (fNam == "false") {fNam = false;}
			else {fNam = true;}
			vSpace = catDef[5]*1;
			tSiz = catDef[6]*1;
			jLft = catDef[7];
			if (jLft == "false") {jLft = false;}
			else {jLft = true;}
			jCnt = catDef[8];
			if (jCnt == "false") {jCnt = false;}
			else {jCnt = true;}
			jRgt = catDef[9];
			if (jRgt == "false") {jRgt = false;}
			else {jRgt = true;}
			iCnt = catDef[10];
			if (iCnt == "false") {iCnt = false;}
			else {iCnt = true;}
			fPrp = catDef[11];
			if (fPrp == "false") {fPrp = false;}
			else {fPrp = true;}
			sPct = catDef[12];
			if (sPct == "false") {sPct = false;}
			else {sPct = true;}
			fFra = catDef[13];
			if (fFra == "false") {fFra = false;}
			else {fFra = true;}
		}
		else {
			pVal = 80;
			hOff = 0;
			vOff = 0;
			nNam = true;
			fNam = false;
			vSpace = 2;
			tSiz = 10;
			jLft = true;
			jCnt = false;
			jRgt = false;
			iCnt = true;
			fPrp = false;
			sPct = false;
			fFra = false;
		}
		// appeler la fonction qui prpare le dialogue
		askUser(nMain);
		// composer une chane de texte avec les prfrences
		var tmpList = new Array (pVal,hOff,vOff,nNam,fNam,vSpace,tSiz,jLft,jCnt,jRgt,iCnt,fPrp,sPct,fFra);
		var curDef = tmpList.join("\n");
		// appleler la fonction qui crit le rsultat dans un fichier
		writeResult(curDef);
		reStore();
		alert ("Termin.", " ");
	}
	else {
		reStore();
		alert ("Le dossier slctionn ne contient pas de fichiers d'images importables.");
	}
}

// la fonction qui dresse la liste des images (sans tenir compte des sous-dossiers)
function getMainFiles(selFolder, mainList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
		}
		else {
			if (f[i].name[0] != ".") {
				mainList.push(f[i]);
			}
		}
	}
	return mainList;
}

// la premire partie du filtre des fichiers
function fileFilter1(mainFiles){
	var curFileList = new Array ();
	for (var i=0; i<mainFiles.length; i++) {
		curFile = mainFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// la deuxime partie du filtre des fichiers (version Mac OS) 
// ncessaire parce qu'il y a souvent des fichiers sans suffixe
function fileFilter2(curFile){
	var curFileType = curFile.type;
	switch (curFileType){
		case "JPEG":
		case "EPSF":
		case "PICT":
		case "TIFF":
		case "8BPS":
		case "GIFf":
		case "PDF ":
			return true;
			break;
		default:
		var curName = curFile.name.toLowerCase();
		try {
			var curItems = curName.split(".");
			var curSuf = "|." + curItems[(curItems.length)-1] + "|";
			if (sufString.indexOf(curSuf) != -1) {
				return true;
			}
			else {
				return false;
			}
		}
		catch (e) {
			return false;
		}
	}
}

// la fonction qui prpare les informations
function getPrefs() {
	var defStr = "";
	// lire le fichier contenant les rglages mmoriss
	var tempFolder = Folder.temp;
	var f = new File(tempFolder + "/loadPrefs.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// la fonction qui prpare le dialogue, l'affiche et convertit les valeurs
function askUser(nMain) {
	// effacer des dialogues rests ouverts
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var labelWidth = 130; 
	var aDialog = app.dialogs.add({name:"Importer des images"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Le dossier source:", minWidth:140});
			staticTexts.add({staticLabel:"" + nMain});
			staticTexts.add({staticLabel:"fichiers image    "});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Echelle:", minWidth:labelWidth});
					if (pVal == "") {
						var percentField = textEditboxes.add({editContents:"", minWidth:36});
					}
					else {
						pVal = pVal*1;
						var percentField = realEditboxes.add({editValue:pVal, minWidth:36});
					}
					staticTexts.add({staticLabel:"%  "});
					staticTexts.add({staticLabel:" ", minWidth:84});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Dcalage horizontal:", minWidth:labelWidth});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:79});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Dcalage vertical:", minWidth:labelWidth});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Adapter images:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var fitButtons = radiobuttonGroups.add();
						with (fitButtons) {
							radiobuttonControls.add({staticLabel:"centrer", checkedState:iCnt});
							radiobuttonControls.add({staticLabel:"proportionnellement", checkedState:fPrp});
							radiobuttonControls.add({staticLabel:"au % le plus petit", checkedState:sPct});
							radiobuttonControls.add({staticLabel:"le bloc au contenu", checkedState:fFra});
						}
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"La lgende:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var labelsButtons = radiobuttonGroups.add();
						with (labelsButtons) {
							radiobuttonControls.add({staticLabel:"aucune", checkedState:nNam});
							radiobuttonControls.add({staticLabel:"le nom du fichier", checkedState:fNam});
						}
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Distance verticale:", minWidth:labelWidth});
					var verticalSpace = realEditboxes.add({editValue:vSpace, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" ", minWidth:79});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Corps:", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:36});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"La justification:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var justButtons = radiobuttonGroups.add();
						with (justButtons) {
							radiobuttonControls.add({staticLabel:" gauche", checkedState:jLft});
							radiobuttonControls.add({staticLabel:"centre", checkedState:jCnt});
							radiobuttonControls.add({staticLabel:" droite", checkedState:jRgt});
						}
					}
				}
			}
		}
	}
	// afficher le dialogue et convertir les entres
	var dResult = aDialog.show();
	if (dResult == true) {
		try {
			var pValue = percentField.editValue;
		}
		catch (e) {
			var pValue = (percentField.editContents)*1;
		}		
		pVal = pValue;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		var fitType = fitButtons.selectedButton;
		var fBtn = fitType;
		if (fBtn == 0) {
			iCnt = true;
			fPrp = false;
			sPct = false;
			fFra = false;
		}
		else if (fBtn == 1) {
			iCnt = false;
			fPrp = true;
			sPct = false;
			fFra = false;
		}
		else if (fBtn == 2) {
			iCnt = false;
			fPrp = false;
			sPct = true;
			fFra = false;
		}
		else if (fBtn == 3) {
			iCnt = false;
			fPrp = false;
			sPct = false;
			fFra = true;
		}
		var selLabel = labelsButtons.selectedButton;
		var rBtn = selLabel;
		if (rBtn == 0) {
			nNam = true;
			fNam = false;
		}
		else if (rBtn == 1) {
			nNam = false;
			fNam = true;
		}
		vSpace = verticalSpace.editValue;
		tSiz = typeSize.editValue;
		var justType = justButtons.selectedButton;
		var jBtn = justType;
		if (jBtn == 0) {
			jLft = true;
			jCnt = false;
			jRgt = false;
			txtJust = Justification.leftAlign;
		}
		else if (jBtn == 1) {
			jLft = false;
			jCnt = true;
			jRgt = false;
			txtJust = Justification.centerAlign;
		}
		else if (jBtn == 2) {
			jLft = false;
			jCnt = false;
			jRgt = true;
			txtJust = Justification.rightAlign;
		}
		makeImageCatalog(mainFileList, pVal, selLabel, vSpace, hOff, vOff);
	}
	else {
		aDialog.destroy();
		reStore();
		exit();
	}
	aDialog.destroy();
}

// crire le rsultat dans un fichier
function writeResult(curDef) {
	var tempFolder = Folder.temp;
	var f = new File(tempFolder + "/loadPrefs.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		f.encoding = "ISO-8851-9" 
		f.write(curDef);
		f.close();
	}
}

// la fonction qui cre le document et les blocs, 
// puis importe les images et place les lgendes
function makeImageCatalog(mainFileList, pVal, selLabel, vSpace, hOff, vOff) {
	var ctr = 0;
	var curPage, curFile, x1, y1, x2, y2, curRect, labelStyle, labelLayer;
	var nSpreads = (Math.round(nMain/nFra)) -1;
	// dupliquer la planche
	for (var i=0; i<nSpreads; i++) {
		curDoc.spreads.item(-1).duplicate();
	}
	var nPages = curDoc.pages.length;
	if(selLabel > 0){
		// crer la feuille de style de paragraphe "legende"
		labelStyle = curDoc.paragraphStyles.item("legende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add();
			labelStyle.name = "legende";
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		// crer le calque "legendes"
		var labelLayer = curDoc.layers.item("legendes");
		try {
			labelLayer.name;
		}
		catch (e){
			labelLayer = curDoc.layers.add();
			labelLayer.name = "legendes";
		}
	}
	var oldPc, newPc;
	for (var p=0; p<nPages; p++) {
		curFrames = curDoc.pages[p].rectangles;
		nFrames = curFrames.length;
		for (var f=nFrames-1; f>-1; f--) {
			curFile = mainFileList[ctr];
			curRect = curFrames[f];
			try {
				curRect.place(File(curFile));
				ctr++;
				if (pVal == "") {
					// appliquer les options
					if (iCnt) {
						curRect.fit(FitOptions.centerContent);
					}
					if (fPrp) {
						curRect.fit(FitOptions.proportionally);
						curRect.fit(FitOptions.centerContent);
					}
					if (sPct) {
						// adapter le contenu proportionnellement
						curRect.fit(FitOptions.fillProportionally);
						// mmoriser le pourcentage
						oldPc = curRect.allGraphics[0].horizontalScale;
						// arrondir  une position aprs la virgule
						newPc = Math.ceil((oldPc*10) + 0.5) / 10;
						// appliquer la nouvelle valeur
						curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
						// centrer l'image
						curRect.fit(FitOptions.centerContent);
					}
				}
				else {
					curRect.allGraphics[0].properties = {horizontalScale:pVal, verticalScale:pVal};
					if (hOff !=0 || vOff !=0) {
						curRect.allGraphics[0].move(undefined,[hOff, vOff]);
					}
					if (iCnt) {
						curRect.fit(FitOptions.centerContent);
					}
				}
				if (fFra) {
					if (pVal == "") {
						curRect.fit(FitOptions.proportionally);
					}
					curRect.fit(FitOptions.frameToContent);
				}
				// insrer la lgende (si dsir)
				if (selLabel == 1) {
					bH = tSiz/2;
					gB = curRect.geometricBounds;
					x1 = gB[1];
					y1 = gB[2]+vSpace;
					x2 = gB[3];
					y2 = y1+bH;
					labelString = curRect.allGraphics[0].itemLink.name;
					textFrame = curRect.parent.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
					textFrame.texts[0].appliedParagraphStyle = labelStyle;
				}
			}
			catch (e) {
			}
		}
	}
}

// restaurer les units et le point de rfrence (si ncessaire)
function reStore() {
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (trp != 1095660652) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}